﻿// chapter2-1.cpp : 

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "wavefile.h"

#define SRATE 	44100 // サンプリングレート 44.1kHz
#define PI 3.1415928
FILE* outfp;
char filename[10] = "out.wav";

int main()
{
	MONO_PCM  pcm;		// モノラルのPCMヘッダ
	pcm.fs = SRATE; 			// サンプリングレート
	pcm.bits = 16; 				// 量子化精度
	pcm.length = SRATE * 4.0; 	// データの長さ 8sec
	pcm.s = (double*)calloc(pcm.length, sizeof(double));  //メモリ確保

	double amplitude;			// 振幅、周波数
	amplitude = 0.6; 			// 振幅
	double f0 = 440.0;			// ラA4の周波数 Hz

	// sin波のデータ生成
	unsigned int count;
	int n = 0;
	for (count = 0; count < pcm.length; count++) {
		pcm.s[count + n * SRATE] = amplitude * sin(2.0 * PI * f0 * count / pcm.fs);
		// 複合音の場合は以下を有効にする
		//pcm.s[count + n * SRATE] += amplitude / 2.0 * sin(2.0 * PI * f0 * 2.0 * count / pcm.fs);
		//pcm.s[count + n * SRATE] += amplitude / 3.0 * sin(2.0 * PI * f0 * 3.0 * count / pcm.fs);
		//pcm.s[count + n * SRATE] += amplitude / 4.0 * sin(2.0 * PI * f0 * 4.0 * count / pcm.fs);
		//pcm.s[count + n * SRATE] /= 4.0;
	}

	// WAVファイルに書き出す
	wavWriteMono(&pcm, filename);
	free(pcm.s);

	return 0;
}

// プログラムの実行: Ctrl + F5 または [デバッグ] > [デバッグなしで開始] メニュー
// プログラムのデバッグ: F5 または [デバッグ] > [デバッグの開始] メニュー
